Index: /trunk/configure.ac
===================================================================
--- /trunk/configure.ac	(revision 584)
+++ /trunk/configure.ac	(revision 1)
@@ -1975,9 +1362,70 @@
 
 
+dnl
+dnl  NETWORK OPTIONS
+dnl
+
+
+AC_ARG_ENABLE(network,
+        [  --enable-network=[[client|server]]	compile client or server [[no]]],
+        [
+        if test "x$enable_network" = xclient; then
+                mytclient="-DSH_WITH_CLIENT"
+		yulectl_prg=
+                setpwd_prg="samhain_setpwd"
+                sh_main_prg="samhain"
+		if test "x${sh_have_gmp}" = xyes
+		then
+			LIBS="-lgmp $LIBS"
+		fi
+dnl		AC_CHECK_HEADER(sys/capability.h, 
+dnl				[AC_CHECK_LIB(cap, cap_get_proc,,sh_use_lcaps="no")],
+dnl				[sh_use_lcaps="no"])
+	elif test "x$enable_network" = xserver; then
+                mytclient="-DSH_WITH_SERVER"
+		yulectl_prg="yulectl"
+                setpwd_prg="samhain_setpwd"
+                sh_main_prg="yule"
+		if test "x${sh_have_gmp}" = xyes
+		then
+			LIBS="-lgmp $LIBS"
+		fi
+		sh_use_lcaps="undef"
+        elif test "x$enable_network" = xno; then
+                mytclient="-DSH_STANDALONE"
+		yulectl_prg=
+                setpwd_prg=
+                sh_main_prg="samhain"
+dnl		AC_CHECK_HEADER(sys/capability.h, 
+dnl				[AC_CHECK_LIB(cap, cap_get_proc,,sh_use_lcaps="no")],
+dnl				[sh_use_lcaps="no"])
+	else
+		AC_MSG_ERROR([--enable-network=WHAT: WHAT must be client, server, or no])
+        fi
+        ],
+        [
+        mytclient="-DSH_STANDALONE"
+	setpwd_prg=
+	yulectl_prg=
+	sh_main_prg="samhain"
+dnl	AC_CHECK_HEADER(sys/capability.h, 
+dnl			[AC_CHECK_LIB(cap, cap_get_proc,,sh_use_lcaps="no")],
+dnl			[sh_use_lcaps="no"])
+        ],
+)
+AC_SUBST(setpwd_prg)
+AC_SUBST(yulectl_prg)
+AC_SUBST(sh_main_prg)
+AC_SUBST(mytclient)
+
+# needed for the rpm spec
+clmytclient=`echo ${mytclient} | sed s%\-%%`
+AC_SUBST(clmytclient)
+
 AC_ARG_ENABLE(udp,
         [  --enable-udp			server can listen on port 514/udp [[no]]],
         [
         if test "x${enable_udp}" = xyes; then
-                AC_DEFINE([INET_SYSLOG], [1], [server may listen on 514/udp for syslog reports])
+                AC_DEFINE(INET_SYSLOG)
         fi
         ]
@@ -1990,10 +1438,14 @@
         if test "x${enable_encrypt}" = xno; then
 	   myencrypt=no
+	elif test "x${enable_encrypt}" = "x1"; then
+	   myencrypt=1  
         fi
         ]
 )
 if test "x${myencrypt}" = "xyes"; then
-        AC_DEFINE([SH_ENCRYPT], [1], [client/server encryption])
-        AC_DEFINE([SH_ENCRYPT_2], [1], [client/server encryption v2])
+        AC_DEFINE(SH_ENCRYPT)
+        AC_DEFINE(SH_ENCRYPT_2)
+elif test "x${myencrypt}" = "x1"; then
+        AC_DEFINE(SH_ENCRYPT)
 fi
 
@@ -2008,5 +1460,5 @@
 )
 if test "x${sh_use_srp_proto}" = xyes; then
-        AC_DEFINE([USE_SRP_PROTOCOL], [1], [auth with SRP])
+        AC_DEFINE(USE_SRP_PROTOCOL)
 fi
 
@@ -2015,9 +1467,9 @@
         [
 	echo "${withval}" | grep ['[^0123456789]'] >/dev/null 2>&1 &&
-		AC_MSG_ERROR([For --with-port=PORT, PORT must be numeric.])
+		AC_MSG_ERROR([--with-port: PORT must be numeric])
 	myport=${withval}
 	],
 	[myport="49777"])
-AC_DEFINE_UNQUOTED([SH_DEFAULT_PORT], [${myport}], [TCP port for client/server connection])
+AC_DEFINE_UNQUOTED(SH_DEFAULT_PORT, ${myport})
 AC_SUBST(myport)
 
@@ -2035,5 +1487,5 @@
 	],
         [mylogsrv="NULL"])
-AC_DEFINE_UNQUOTED([DEFAULT_LOGSERVER], [_("${mylogsrv}")], []  )
+AC_DEFINE_UNQUOTED(DEFAULT_LOGSERVER, _("${mylogsrv}") )
 AC_SUBST(mylogsrv)
 
@@ -2051,5 +1503,5 @@
 	],
         [myaltlogsrv="NULL"])
-AC_DEFINE_UNQUOTED([ALT_LOGSERVER], [_("${myaltlogsrv}")], [] )
+AC_DEFINE_UNQUOTED(ALT_LOGSERVER, _("${myaltlogsrv}"))
 
 
@@ -2064,30 +1516,29 @@
         [
 	if test "x${enableval}" != "x"; then
-		AC_DEFINE([SH_STEALTH_NOCL], [1], [restrict CL parsing])
+		AC_DEFINE(SH_STEALTH_NOCL)
 	fi
 	if test "x${enableval}" = "xstop" || test "x${enableval}" = "xstart"; then
-	  AC_MSG_ERROR([For --enable-nocl=PW start/stop/reload/restart/status are reserved words.])
+	  AC_MSG_ERROR([--enable-nocl: start/stop/reload/restart/status are reserved words])
 	fi
 	if test "x${enableval}" = "xreload" || test "x${enableval}" = "xrestart"; then
-	  AC_MSG_ERROR([For --enable-nocl=PW start/stop/reload/restart/status are reserved words.])
+	  AC_MSG_ERROR([--enable-nocl: start/stop/reload/restart/status are reserved words])
 	fi
 	if test "x${enableval}" = "xstatus"; then
-	  AC_MSG_ERROR([For --enable-nocl=PW start/stop/reload/restart/status are reserved words.])
+	  AC_MSG_ERROR([--enable-nocl: start/stop/reload/restart/status are reserved words])
 	fi
 	if test "x${enableval}" = "xno"; then
-	  AC_MSG_ERROR([With --enable-nocl=PW, the use of --enable-nocl=no is ambiguous.])
+	  AC_MSG_ERROR([--enable-nocl: use of --enable-nocl=no is ambiguous])
 	fi
 	nocl_code="${enable_nocl}"
 	]
 )
-AC_DEFINE_UNQUOTED([NOCL_CODE], [_("${nocl_code}")], [code to enable CL parsing] )
+AC_DEFINE_UNQUOTED(NOCL_CODE, _("${nocl_code}") )
 AC_SUBST(nocl_code)
 AC_ARG_ENABLE(stealth,
         [  --enable-stealth=XOR_VAL	enable stealth mode [[no]]],
-        [
-	AC_DEFINE([SH_STEALTH], [1], [enable stealth mode])
+        [AC_DEFINE(SH_STEALTH)
 	if test "x${enableval}" != "xyes"; then
 		echo "${enableval}" | grep ['[^0123456789]'] >/dev/null 2>&1 &&
-			AC_MSG_ERROR([For --enable-stealth=XOR_VAL, XOR_VAL must be numeric.])
+			AC_MSG_ERROR([--enable-stealth: XOR_VAL must be numeric])
 		if test "${enableval}" -lt 127 || test "${enableval}" -gt 255; then
 			if test x"${enableval}" = x0
@@ -2095,5 +1546,5 @@
 				:
 			else
-				AC_MSG_ERROR([For --enable-stealth=XOR_VAL, XOR_VAL must be in the range 127 to 255.])
+				AC_MSG_ERROR([--enable-stealth: XOR_VAL must be in the range 127 to 255])
 			fi
 		fi
@@ -2111,9 +1562,9 @@
         [  --enable-micro-stealth=XOR_VAL	enable micro stealth mode [[no]]],
         [
-	AC_DEFINE([SH_STEALTH], [1], [enable stealth mode])
-	AC_DEFINE([SH_STEALTH_MICRO], [1], [enable micro stealth mode])
+	AC_DEFINE(SH_STEALTH)
+	AC_DEFINE(SH_STEALTH_MICRO)
 	if test "x${enableval}" != "xyes"; then
 		echo "${enableval}" | grep ['[^0123456789]'] >/dev/null 2>&1 &&
-			AC_MSG_ERROR([For --enable-micro-stealth=XOR_VAL, XOR_VAL must be numeric.])
+			AC_MSG_ERROR([--enable-micro-stealth: XOR_VAL must be numeric])
 		if test "${enableval}" -lt 127 || test "${enableval}" -gt 255; then
 			if test x"${enableval}" = x0
@@ -2121,5 +1572,5 @@
 				:
 			else
-				AC_MSG_ERROR([For --enable-micro-stealth=XOR_VAL, XOR_VAL must be in the range 127 to 255.])
+				AC_MSG_ERROR([--enable-micro-stealth: XOR_VAL must be in the range 127 to 255])
 			fi
 		fi
@@ -2161,9 +1612,9 @@
 	fi
 	echo "${myident}" | grep ['[^0123456789]'] >/dev/null 2>&1 || \
-		AC_MSG_ERROR([With --enable-identity=USER, please supply a username, not a UID.])
+		AC_MSG_ERROR([--enable-identity: need username, not UID])
 	myident_uid=`(cat /etc/passwd; ypcat passwd) 2>/dev/null |\
 	  grep "^${myident}:" | awk -F: '{ print $3; }'`
 	if test x"${myident_uid}" = x; then
-	  AC_MSG_WARN([Option --enable-identity used, user ${myident} will be added upon install.])
+	  AC_MSG_WARN([--enable-identity: user ${myident} will be added upon install])
 	  need_user_install=1
 	fi
@@ -2187,8 +1638,85 @@
 	fi
 	])
-AC_DEFINE_UNQUOTED([DEFAULT_IDENT], [_("${myident}")], [use this as install name] )
+AC_DEFINE_UNQUOTED(DEFAULT_IDENT, _("${myident}") )
 AC_SUBST(myident)
 AC_SUBST(need_user_install)
 
+sh_insmod_cmd=": # no kernel module"
+sh_lkm=""
+lkm_inc=""
+khidemap="/boot/System.map"
+sh_syscalltable="0x0"
+AC_ARG_ENABLE(khide,
+	[  --enable-khide=SYSTEM_MAP		use kernel module to hide (Linux only)[[/boot/System.map]]],
+	[
+	if test "x${enable_khide}" != xno; then
+	   if test "x${enableval}" != "xyes"; then
+		khidemap="${enableval}"
+	   fi
+	   sh_syscalltable=`grep 'D sys_call_table' ${khidemap} | awk '{print $1}'`
+	   if test x"$sh_syscalltable" = x; then
+		sh_syscalltable=`grep 'd sys_call_table' ${khidemap} | awk '{print $1}'`
+		if test x"$sh_syscalltable" = x; then
+			AC_MSG_ERROR([--enable-khide: symbol sys_call_table not found in ${khidemap}])
+		fi
+	   fi
+	   sh_syscalltable="0x${sh_syscalltable}"
+	   install_name_len=`echo ${install_name} | awk '{ print(length()); }'`
+	   if test "${install_name_len}" -gt 15 ; then
+		AC_MSG_ERROR([--enable-khide: install_name exceeds 15 char length limit])
+	   fi
+	   AC_DEFINE(SH_USE_LKM)
+	   AC_DEFINE_UNQUOTED(SH_MAGIC_HIDE, "${install_name}")
+
+	   # -- NEW --
+	   kernel_version=`uname -r | sed s,2.6.*,LINUX26,`
+	   if test x"$kernel_version" = xLINUX26
+	   then
+		sh_modlist_lock=`egrep ['[bd] modlist_lock$'] ${khidemap} | awk '{print $1}'` 
+		if test x"$sh_modlist_lock" = x; then
+			AC_MSG_ERROR([--enable-khide: symbol modlist_lock not found in ${khidemap}])
+		fi
+		sh_modlist_lock="0x${sh_modlist_lock}"
+		AC_DEFINE_UNQUOTED(SH_MODLIST_LOCK, ${sh_modlist_lock}, [The address of the modules list spinlock])
+
+		sh_list_modules=`egrep 'd modules$' ${khidemap} | awk '{print $1}'` 
+		if test x"$sh_list_modules" = x; then
+			AC_MSG_ERROR([--enable-khide: symbol modules not found in ${khidemap}])
+		fi
+		sh_list_modules="0x${sh_list_modules}"
+		AC_DEFINE_UNQUOTED(SH_LIST_MODULES, ${sh_list_modules}, [The address of the modules list])
+
+		AC_DEFINE(LINUX26, 1, [Define if kernel is 2.6])
+	   	sh_insmod_cmd="modprobe ${install_name}_hide"
+	   	sh_lkm="samhain_hide.ko"
+	   else
+		sh_insmod_cmd="insmod ${install_name}_hide; insmod ${install_name}_erase; rmmod ${install_name}_erase"
+		sh_lkm="samhain_hide.o samhain_erase.o"
+	   fi
+	   # -- END NEW --
+
+	   kvers=`uname -r`
+	   if test -f /lib/modules/${kvers}/build/include/linux/kernel.h; then
+		lkm_inc="-I/lib/modules/${kvers}/build/include"
+	   else
+		AC_MSG_WARN([--enable-khide: /lib/modules/${kvers}/build/include/linux not found])
+		AC_MSG_WARN([--enable-khide: You may need to install the kernel-source])
+		AC_MSG_WARN([--enable-khide: headers for the currently-running kernel.])
+	   fi
+	   sh_is_vanilla_kernel=yes
+	   if test -f /lib/modules/${kvers}/build/include/linux/sched.h; then
+		grep 'next_task,' /lib/modules/${kvers}/build/include/linux/sched.h  >/dev/null 2>&1 || sh_is_vanilla_kernel=no
+	   fi
+	   if test x"${sh_is_vanilla_kernel}" = xno; then
+		echo "This is not a 2.4 vanilla kernel"
+	   else
+		AC_DEFINE(SH_VANILLA_KERNEL)
+	   fi
+	fi
+	]
+)
+AC_SUBST(lkm_inc)
+AC_SUBST(sh_lkm)
+AC_SUBST(sh_insmod_cmd)
 AC_SUBST(install_name)
 AC_SUBST(INSTALL_NAME)
@@ -2196,5 +1724,6 @@
 AC_SUBST(xor_code)
 
-AC_DEFINE_UNQUOTED([XOR_CODE], [${xor_code}], [] )
+AC_DEFINE_UNQUOTED(XOR_CODE, ${xor_code})
+AC_DEFINE_UNQUOTED(SH_SYSCALLTABLE, ${sh_syscalltable})
 
 
@@ -2203,7 +1732,7 @@
 exepack_state2=`${srcdir}/c_random.sh 2>/dev/null`
 
-AC_DEFINE_UNQUOTED([EXEPACK_STATE_0], [${exepack_state0}], [exepack init key p1])
-AC_DEFINE_UNQUOTED([EXEPACK_STATE_1], [${exepack_state1}], [exepack init key p2])
-AC_DEFINE_UNQUOTED([EXEPACK_STATE_2], [${exepack_state2}], [exepack init key p3])
+AC_DEFINE_UNQUOTED(EXEPACK_STATE_0, ${exepack_state0})
+AC_DEFINE_UNQUOTED(EXEPACK_STATE_1, ${exepack_state1})
+AC_DEFINE_UNQUOTED(EXEPACK_STATE_2, ${exepack_state2})
 
 
@@ -2212,9 +1741,37 @@
 	[
 	if test "x${enableval}" = "xyes"; then 
-		AC_DEFINE([SH_USE_SUIDCHK], [1], [check for suid/sgid files])
+		AC_DEFINE(SH_USE_SUIDCHK)
 	fi
 	]
 )
 
+
+systemmap="/boot/System.map"
+sh_libkvm=""
+AC_ARG_WITH(kcheck,
+	[  --with-kcheck=SYSTEM_MAP	check Linux kernel integrity [[/boot/System.map]]],
+	[
+	if test "x${withval}" != "xno"; then 
+		AC_DEFINE(SH_USE_KERN)
+		kernelversion=`uname -r`
+		AC_DEFINE_UNQUOTED(SH_KERNEL_VERSION, _("${kernelversion}"), [Define the kernel version])
+		if test "x${withval}" != "xyes"; then
+			systemmap="${withval}"
+		fi
+		if test "x${cross_compiling}" = xyes; then
+			:
+		elif test "x$selectconfig" = "xfreebsd"; then
+			LIBS="$LIBS -lkvm"
+			sh_libkvm="-lkvm"
+		elif test -f "${systemmap}"; then 
+			:
+		else
+			AC_MSG_ERROR([--with-kcheck: cannot find system map ${systemmap}])
+		fi
+	fi
+	]
+)
+AC_SUBST(systemmap)
+AC_SUBST(sh_libkvm)
 
 AC_ARG_ENABLE(base,
@@ -2226,13 +1783,13 @@
         AC_MSG_RESULT(${my_key_A} ${my_key_B})
 	if test "x${my_key_A}" = x; then
-		AC_MSG_ERROR([Option --enable-base=B1,B2 used with invalid first base key (zero length).])
+		AC_MSG_ERROR([--enable-base: first base key has zero length])
 	fi
 	if test "x${my_key_B}" = x; then
-		AC_MSG_ERROR([Option --enable-base=B1,B2 used with invalid second base key (zero length).])
+		AC_MSG_ERROR([--enable-base: second base key has zero length])
 	fi
 	echo "${my_key_A}" | grep ['[^0123456789]'] >/dev/null 2>&1 &&
-		AC_MSG_ERROR([For --enable-base=B1,B2,  B1 and B2 must be numeric in the range 0 to 2147483647.])
+		AC_MSG_ERROR([--enable-base: base key must be numeric in the range 0 to 2147483647])
 	echo "${my_key_B}" | grep ['[^0123456789]'] >/dev/null 2>&1 &&
-		AC_MSG_ERROR([For --enable-base=B1,B2,  B1 and B2 must be numeric in the range 0 to 2147483647.])
+		AC_MSG_ERROR([--enable-base: base key must be numeric in the range 0 to 2147483647])
         ],
         [
@@ -2283,107 +1840,18 @@
 pos_tf=`expr $pos_tf_2 + 1`
 AC_MSG_RESULT(${pos_tf})
-AC_DEFINE_UNQUOTED([POS_TF], [${pos_tf}], []  )
+AC_DEFINE_UNQUOTED(POS_TF, ${pos_tf} )
 
 mykeybase=`echo ${my_key_A},${my_key_B}`
-AC_DEFINE_UNQUOTED([DEFKEY], [${mykeybase}], []  )
+AC_DEFINE_UNQUOTED(DEFKEY, ${mykeybase} )
 AC_SUBST(mykeybase)
 
 
 dnl
-dnl  Signify/GnuPG options
+dnl  GPG/PGP options
 dnl 
-
-AC_ARG_WITH(signify,
-        [  --with-signify=PATH 		use OpenBSD signify to verify database/config [[no]]],
-        [
-	if test "x${withval}" != "xno"; then
-	  if test "x${cross_compiling}" = xyes; then
-		mysignify="${withval}"
-	  else
-		if test -f "${withval}"; then
-		  mysignify="${withval}"
-		  mychk0=`gpg --load-extension tiger --print-md TIGER192 ${withval} 2>/dev/null`
-		  if test "x$?" != "x0"; then
-		    mychktest=no
-		    for sam_pre in ./samhain ./yule /usr/local/sbin/samhain /usr/local/bin/samhain /usr/bin/samhain /usr/sbin/samhain /usr/local/sbin/yule /usr/local/bin/yule /usr/bin/yule /usr/sbin/yule; do
-		      if test x"${mychktest}" = xyes
-		      then
-			:
-		      else
-		        if test -f ${sam_pre}
-		        then
-			  echo "use existing ${sam_pre} for signify checksum"
-			  mychk0=`${sam_pre} -H ${withval} 2>/dev/null`
-			  if test "x$?" != "x0"; then
-			    if test "x${nocl_code}" != "x"; then
-			       mychk0=`echo -H ${withval} | ${sam_pre} ${nocl_code} 2>/dev/null`
-			       if test "x$?" != "x0"; then
-			       	  :
-			       else
-			          mychk="${mychk0}"
-				  mychktest=yes
-			       fi 
-			    fi
-			  else
-			    mychk="${mychk0}"
-			    mychktest=yes
-			  fi
-		        fi
-		      fi
-		    done
-		    if test x${mychktest} = xno; then
-		      AC_MSG_WARN([--with-signify: cannot determine TIGER192 checksum of ${withval}])
-		      echo "-------------------------------------------------------------"
-		      echo " I cannot find an existing GnuPG or samhain binary to use."
-		      echo " You can:"
-		      echo "   (a) run make to compile a samhain binary, then repeat"
-		      echo "       ./configure and make"
-		      echo "   (b) ignore the failure. The checksum of the signify binary"
-		      echo "       will not get compiled in, thus allowing an attacker"
-		      echo "       to replace signify with a trojan and subverting the"
-		      echo "       signature verification of configure and database files."
-		      echo
-		      echo " PLEASE IGNORE THIS MESSAGE IF YOU ALSO USE --with-checksum"
-		      echo "-------------------------------------------------------------"
-		    fi
-		  else
-		    mychk="${mychk0}"
-		  fi
-		else
-		  AC_MSG_ERROR([--with-signify: cannot find signify PATH=${withval}])
-		fi
-	  fi
-	  AC_DEFINE([WITH_SIG], [1], [Define if signature checking is supported.])
-	  AC_DEFINE([WITH_SIGNIFY], [1], [Define if using OpenBSD signify for signature checking.])
-	  AC_DEFINE_UNQUOTED([DEFAULT_SIG_PATH], [_("${mysignify}")], [Define as path to signing binary])
-	  AC_SUBST(mysignify)
-	fi
-	]
-)
-
-AC_ARG_WITH(pubkey-checksum,
-        [  --with-pubkey-checksum=CHKSUM	compile in TIGER192 checksum of signify public key [[no]]],
-        [
-	if test "x${withval}" != "xno"; then
-		if test "x${withval}" == "xyes"; then
-		   	AC_MSG_ERROR([Option --with-pubkey-checksum=CHKSUM: checksum CHKSUM of signify public key not specified.])
-		else
-			if test "x${withval}" = "x"; then
-				AC_MSG_ERROR([Option --with-checksum=CHKSUM: checksum CHKSUM of the signify public key not specified.])
-			fi
-		fi
-		AC_DEFINE([HAVE_SIG_KEY_HASH], [1], [Define if signing binary checksum available.])
-		AC_DEFINE_UNQUOTED([SIG_KEY_HASH], [_("${withval}")], [Define as the signify public key checksum.] )
-	fi
-	]
-)
-
 
 AC_ARG_WITH(gpg,
         [  --with-gpg=PATH 		use GnuPG to verify database/config [[no]]],
         [
-	if test "x${mysignify}" != "x"; then
-	   AC_MSG_ERROR([--with-gpg: already using --with-signify])
-	fi
 	if test "x${withval}" != "xno"; then
 	  if test "x${cross_compiling}" = xyes; then
@@ -2405,13 +1873,5 @@
 			  mychk0=`${sampre} -H ${withval} 2>/dev/null`
 			  if test "x$?" != "x0"; then
-			    if test "x${nocl_code}" != "x"; then
-			       mychk0=`echo -H ${withval} | ${sampre} ${nocl_code} 2>/dev/null`
-			       if test "x$?" != "x0"; then
-			       	  :
-			       else
-			          mychk="${mychk0}"
-				  mychktest=yes
-			       fi 
-			    fi
+			    :
 			  else
 			    mychk="${mychk0}"
@@ -2433,6 +1893,4 @@
 		      echo "       to replace gpg with a trojan and subverting the gpg"
 		      echo "       signature verification of configure and database files."
-		      echo
-		      echo " PLEASE IGNORE THIS MESSAGE IF YOU ALSO USE --with-checksum"
 		      echo "-------------------------------------------------------------"
 		    fi
@@ -2441,10 +1899,9 @@
 		  fi
 		else
-		  AC_MSG_ERROR([--with-gpg: cannot find GnuPG PATH=${withval}])
+		  AC_MSG_WARN([--with-gpg: cannot find GnuPG PATH=${withval}])
 		fi
 	  fi
-	  AC_DEFINE([WITH_SIG], [1], [Define if signature checking is supported.])
-	  AC_DEFINE([WITH_GPG], [1], [] )
-	  AC_DEFINE_UNQUOTED([DEFAULT_SIG_PATH], [_("${mygpg}")], [Define as path to signing binary])
+	  AC_DEFINE(WITH_GPG)
+	  AC_DEFINE_UNQUOTED(DEFAULT_GPG_PATH, _("${mygpg}") )
 	  AC_SUBST(mygpg)
 	fi
@@ -2452,27 +1909,13 @@
 )
 
-
-
-AC_ARG_WITH(keyid,
-	[  --with-keyid=KEYID		specify KeyID (0x...) for GPG/PGP functions [[none]]],
-	[
-	if test "x${withval}" != "x"; then
-		echo "${withval}" | awk '{if((length($0)==10)||(length($0)==18)){exit 2}else{exit 0}}' &&
-		AC_MSG_ERROR([--with-keyid:${withval} must be "0x" + 8|16 hex digits])
-		echo "${withval}" | grep ['[^0][^x][^0123456789ABCDEFabcdef]'] >/dev/null 2>&1 &&
-		AC_MSG_ERROR([--with-keyid:${withval} must be "0x" + 8|16 hex digits])
-		mykeyid="$withval"
-		mykeytag="--default-key"
-	else
-		mykeyid=""
-		mykeytag=""
-	fi
-	AC_SUBST(mykeyid)
-	AC_SUBST(mykeytag)
-	]
-)
+dnl AC_ARG_WITH(pgp,
+dnl        [  --with-pgp=PATH		Use PGP to verify database/config (no).],
+dnl         [myppg="$withval"
+dnl 	AC_DEFINE(WITH_PGP)
+dnl 	AC_DEFINE_UNQUOTED(DEFAULT_PGP_PATH, _("${myppg}") )
+dnl 	])
 
 AC_ARG_WITH(checksum,
-        [  --with-checksum=CHKSUM	compile in checksum of signing binary (e.g. gpg) [[yes]]],
+        [  --with-checksum=CHKSUM	compile in gpg/pgp checksum [[yes]]],
         [
 	if test "x${withval}" != "xno"; then
@@ -2480,5 +1923,5 @@
 			if test "x${mychk}" != "x"; then
 				if test "x${mychk}" != "x${withval}"; then
-					AC_MSG_WARN([--with-checksum: possible signing binary CHKSUM problem])
+					AC_MSG_WARN([--with-checksum: possible gpg CHKSUM problem])
 					AC_MSG_WARN([--with-checksum: CHKSUM=${withval}])
 					AC_MSG_WARN([--with-checksum: autodetected=${mychk}])
@@ -2488,19 +1931,18 @@
 		else
 			if test "x${mychk}" = "x"; then
-				AC_MSG_ERROR([Option --with-checksum=CHKSUM: checksum CHKSUM of the signing binary not specified.])
+				AC_MSG_ERROR([--with-checksum: gpg CHKSUM not specified])
 			fi
 		fi
-		AC_DEFINE([HAVE_SIG_CHECKSUM], [1], [Define if signing binary checksum available.])
-		AC_DEFINE_UNQUOTED([SIG_HASH], [_("${mychk}")], [Define as the signing binary TIGER192 checksum.] )
-		echo "${mychk}" | sed 's,.*:,,g' | sed 's, ,,g' | sed 's,\(.\),\1:,g' | awk '{ split($0, arr, ":"); m = length($1)/2; print "#ifndef CHKSUM_H"; print "#define CHKSUM_H"; print "char sigchk[50];"; for (i=1; i <= m; i++) printf "sigchk[%d] = %c%s%c;\n", i-1, 39, arr[i], 39; printf "sigchk[48] = %c%c0%c;\n", 39, 92, 39; print "#endif"; }' > sh_sig_chksum.h 
+		AC_DEFINE(HAVE_GPG_CHECKSUM)
+		AC_DEFINE_UNQUOTED(GPG_HASH, _("${mychk}") )
+		echo "${mychk}" | sed 's,.*:,,g' | sed 's, ,,g' | sed 's,\(.\),\1:,g' | awk '{ split($0, arr, ":"); m = length($1)/2; print "#ifndef CHKSUM_H"; print "#define CHKSUM_H"; print "char gpgchk[50];"; for (i=1; i <= m; i++) printf "gpgchk[%d] = %c%s%c;\n", i-1, 39, arr[i], 39; printf "gpgchk[48] = %c%c0%c;\n", 39, 92, 39; print "#endif"; }' > sh_gpg_chksum.h 
 	fi
 	],
 	[
-	if test "x${mygpg}" != "x" || test "x${mysignify}" != "x"
-	then
+	if test "x${mygpg}" != "x"; then
 		if test "x${mychk}" != "x"; then
-		   	AC_DEFINE([HAVE_SIG_CHECKSUM], [1], [Define if signing binary checksum available.])
-			AC_DEFINE_UNQUOTED([SIG_HASH], [_("${mychk}")], [Define as the signing binary TIGER192 checksum.] )
-			echo "${mychk}" | sed 's,.*:,,g' | sed 's, ,,g' | sed 's,\(.\),\1:,g' | awk '{ split($0, arr, ":"); m = length($1)/2; print "#ifndef CHKSUM_H"; print "#define CHKSUM_H"; print "char sigchk[50];"; for (i=1; i <= m; i++) printf "sigchk[%d] = %c%s%c;\n", i-1, 39, arr[i], 39; printf "sigchk[48] = %c%c0%c;\n", 39, 92, 39; print "#endif"; }' > sh_sig_chksum.h 
+			AC_DEFINE(HAVE_GPG_CHECKSUM)
+			AC_DEFINE_UNQUOTED(GPG_HASH, _("${mychk}") )
+			echo "${mychk}" | sed 's,.*:,,g' | sed 's, ,,g' | sed 's,\(.\),\1:,g' | awk '{ split($0, arr, ":"); m = length($1)/2; print "#ifndef CHKSUM_H"; print "#define CHKSUM_H"; print "char gpgchk[50];"; for (i=1; i <= m; i++) printf "gpgchk[%d] = %c%s%c;\n", i-1, 39, arr[i], 39; printf "gpgchk[48] = %c%c0%c;\n", 39, 92, 39; print "#endif"; }' > sh_gpg_chksum.h 
 		fi
 	fi
@@ -2516,5 +1958,5 @@
 			echo "${withval0}" | \
 			grep ['[^0123456789abcdefABCDEF]'] >/dev/null 2>&1 &&
-			AC_MSG_ERROR([In option --with-fp=FINGERPRINT, there is an invalid character(s) in FINGERPRINT=${withval0}.])
+			AC_MSG_ERROR([--with-fp: invalid character(s) in FINGERPRINT=${withval0}])
 			sh_len=`echo ${withval0} | wc -c | sed 's% %%g'`
 			sh_len0=`expr ${sh_len} \- 1`
@@ -2522,12 +1964,12 @@
 			then
 				myfp="${withval0}"
-				AC_DEFINE([USE_FINGERPRINT], [1], [] )
-				AC_DEFINE_UNQUOTED([SH_GPG_FP], [_("${myfp}")], []  )
+				AC_DEFINE(USE_FINGERPRINT)
+				AC_DEFINE_UNQUOTED(SH_GPG_FP, _("${myfp}") )
 				echo "${myfp}" | sed 's,.*:,,g' | sed 's, ,,g' | sed 's,\(.\),\1:,g' | awk '{ split($0, arr, ":"); m = length($1)/2; print "#ifndef FINGERPRINT_H"; print "#define FINGERPRINT_H"; printf "char gpgfp[%d];\n", m+1; for (i=1; i <= m; i++) printf "gpgfp[%d] = %c%s%c;\n", i-1, 39, arr[i], 39; printf "gpgfp[%d] = %c%c0%c;\n", m, 39, 92, 39; print "#endif"; }' > sh_gpg_fp.h 
 			else
-				AC_MSG_ERROR([In option --with-fp=FINGERPRINT, the length (${sh_len0}) of FINGERPRINT ${withval0} is incorrect.])
+				AC_MSG_ERROR([--with-fp: length (${sh_len0}) of FINGERPRINT ${withval0} incorrect])
 			fi
 		else
-			AC_MSG_ERROR([For option --with-fp=FINGERPRINT, FINGERPRINT=yes is invalid, please specify a valid key fingerprint.])
+			AC_MSG_ERROR([--with-fp: usage error ... FINGERPRINT=yes])
 		fi
 	fi
@@ -2546,15 +1988,13 @@
 	do
 		case ${sh_item} in
-		*@localhost)
-		;;
 		*@*.*)
 		sh_tmp=`echo ${sh_item} | awk '{ if ($1 ~ [/^[a-zA-Z0-9][a-zA-Z0-9\-_\.]*@[a-zA-Z0-9\-\.]+\.([a-zA-Z]+|[0-9]+)$/]) {print 1; } else { print 0}}'`
 		if test "x${sh_tmp}" != "x1"
 		then
-			AC_MSG_ERROR([Option --with-recipient=ADDR used with invalid mail address ${sh_item}.])
+			AC_MSG_ERROR([--with-recipient: invalid mail address ${sh_item}])
 		fi 
 		;;
 		*)
-		AC_MSG_ERROR([Option --with-recipient=ADDR used with invalid mail address ${sh_item}.])
+		AC_MSG_ERROR([--with-recipient: invalid mail address ${sh_item}])
 		;;
 		esac
@@ -2563,5 +2003,5 @@
 	],
         [myrcp="NULL"])
-AC_DEFINE_UNQUOTED([DEFAULT_MAILADDRESS], [_("${myrcp}")], []  )
+AC_DEFINE_UNQUOTED(DEFAULT_MAILADDRESS, _("${myrcp}") )
 
 
@@ -2574,5 +2014,5 @@
 	mysender="daemon"
 	])
-AC_DEFINE_UNQUOTED([DEFAULT_SENDER], [_("${mysender}")], []  )
+AC_DEFINE_UNQUOTED(DEFAULT_SENDER, _("${mysender}") )
 
 
@@ -2589,5 +2029,5 @@
 	do
 		echo "${sh_tmp1}" | grep ['[^0123456789]'] >/dev/null 2>&1 &&
-			AC_MSG_ERROR([Option --with-trusted=UID used with non-numeric UID in ${withval}.])
+			AC_MSG_ERROR([--with-trusted: non-numeric UID in ${withval}])
 		if test "x${sh_tmp1}" = "x0"
 		then
@@ -2602,8 +2042,6 @@
 	],
         [mytrust="0"] )
-AC_DEFINE_UNQUOTED([SL_ALWAYS_TRUSTED], [${mytrust}], [UIDs of trusted users] )
+AC_DEFINE_UNQUOTED(SL_ALWAYS_TRUSTED, ${mytrust} )
 AC_SUBST(mytrust)
-
-mytmpdir=
 
 AC_ARG_WITH(tmp-dir,
@@ -2611,21 +2049,15 @@
         [
 	if test "x${cross_compiling}" = xyes; then
-		mytmpdir="$withval"
-		AC_DEFINE_UNQUOTED([SH_TMPDIR], [_("${mytmpdir}")], []  )
+		:
 	else
 		if test -d "${withval}"; then
-			mytmpdir="$withval"
-			AC_DEFINE_UNQUOTED([SH_TMPDIR], [_("${mytmpdir}")], []  )
+			my_tmp_dir="$withval"
+			AC_DEFINE_UNQUOTED(SH_TMPDIR, _("${my_tmp_dir}") )
 		else
-			mytmpdir="$withval"
-			AC_DEFINE_UNQUOTED([SH_TMPDIR], [_("${mytmpdir}")], []  )
-			AC_MSG_WARN([--with-tmp-dir: tmp directory ${withval} does not exist])
+			AC_MSG_ERROR([--with-tmp-dir: tmp directory ${withval} does not exist])
 		fi
 	fi
 	]
 )
-
-AC_SUBST(mytmpdir)
-
 
 dnl
@@ -2719,5 +2151,5 @@
 	]
 )
-AC_DEFINE_UNQUOTED([DEFAULT_CONFIGFILE], [_("${myconffile}")], []  )
+AC_DEFINE_UNQUOTED(DEFAULT_CONFIGFILE, _("${myconffile}") )
 AC_SUBST(myconffile)
 AC_SUBST(myrpmconffile)
@@ -2741,6 +2173,6 @@
 	]
 )
-AC_DEFINE_UNQUOTED([DEFAULT_ERRFILE], [_("${mylogfile}")], []  )
-AC_DEFINE_UNQUOTED([DEFAULT_LOGDIR], [_("${mylogdir}")], []  )
+AC_DEFINE_UNQUOTED(DEFAULT_ERRFILE, _("${mylogfile}") )
+AC_DEFINE_UNQUOTED(DEFAULT_LOGDIR, _("${mylogdir}") )
 AC_SUBST(mylogfile)
 AC_SUBST(mylogdir)
@@ -2755,15 +2187,10 @@
 	],
 	[
-	if test -h /var/run && test -d /run; then
-		mylockfile="/run/${install_name}.pid"
-		mylockdir="/run"
-	else
-		mylockfile="${localstatedir}/run/${install_name}.pid"
-		mylockdir="${localstatedir}/run"
-	fi
+	mylockfile="${localstatedir}/run/${install_name}.pid"
+	mylockdir="${localstatedir}/run"
 	]
 )
-AC_DEFINE_UNQUOTED([DEFAULT_ERRLOCK], [_("${mylockfile}")], []  )
-AC_DEFINE_UNQUOTED([DEFAULT_PIDDIR], [_("${mylockdir}")], []  )
+AC_DEFINE_UNQUOTED(DEFAULT_ERRLOCK, _("${mylockfile}") )
+AC_DEFINE_UNQUOTED(DEFAULT_PIDDIR, _("${mylockdir}") )
 AC_SUBST(mylockfile)
 AC_SUBST(mylockdir)
@@ -2795,5 +2222,5 @@
 			echo "It should be REQ_FROM_SERVER/some/local/path"
 		fi
-		AC_MSG_ERROR([Option --with-data-file=FILE used with invalid path ${withval}.])
+		AC_MSG_ERROR([--with-data-file: invalid path ${withval}])
 	fi
 	],
@@ -2802,12 +2229,12 @@
 	myrpmdatafile="${mydatafile}"
 	])
-AC_DEFINE_UNQUOTED([DEFAULT_DATA_FILE], [_("${mydatafile}")], []  )
+AC_DEFINE_UNQUOTED(DEFAULT_DATA_FILE, _("${mydatafile}") )
 AC_SUBST(mydatafile)
 AC_SUBST(myrpmdatafile)
 
-AC_DEFINE_UNQUOTED([DEFAULT_DATAROOT], [_("${mydataroot}")], []  )
+AC_DEFINE_UNQUOTED(DEFAULT_DATAROOT, _("${mydataroot}") )
 AC_SUBST(mydataroot)
 
-AC_DEFINE_UNQUOTED([DEFAULT_QDIR], [_("${mydataroot}/.quarantine")], []  )
+AC_DEFINE_UNQUOTED(DEFAULT_QDIR, _("${mydataroot}/.quarantine") )
 AC_SUBST(myqdir)
 
@@ -2821,5 +2248,5 @@
         myhtmlfile="${mylogdir}/${install_name}.html"
 	])
-AC_DEFINE_UNQUOTED([DEFAULT_HTML_FILE], [_("${myhtmlfile}")], []  )
+AC_DEFINE_UNQUOTED(DEFAULT_HTML_FILE, _("${myhtmlfile}") )
 AC_SUBST(myhtmlfile)
 
@@ -2837,31 +2264,16 @@
 
 
-AC_DEFINE_UNQUOTED([SH_INSTALL_DIR],  [_("${sbindir}")], [] )
-AC_DEFINE_UNQUOTED([SH_INSTALL_PATH], [_("${sbindir}/${install_name}")], [] )
-AC_DEFINE_UNQUOTED([SH_INSTALL_NAME], [_("${install_name}")], [] )
-
-AH_TOP([
-#ifndef SH_CONFIG_H
-#define SH_CONFIG_H
-])
-AH_BOTTOM([
-#ifdef SH_STEALTH
-char * globber(const char * string);
-#define _(string) globber(string) 
-#define N_(string) string
-#else
-#define _(string)  string 
-#define N_(string) string
-#endif
-
-#endif
-])
-AC_CONFIG_HEADERS([config.h])
-AC_CONFIG_FILES([
+AC_DEFINE_UNQUOTED(SH_INSTALL_DIR,  _("${sbindir}"))
+AC_DEFINE_UNQUOTED(SH_INSTALL_PATH, _("${sbindir}/${install_name}"))
+AC_DEFINE_UNQUOTED(SH_INSTALL_NAME, _("${install_name}"))
+
+AC_CONFIG_HEADER(config.h)
+
+AC_OUTPUT(
+[
 Makefile
 samhain-install.sh
 init/samhain.startLSB
 init/samhain.startLinux
-init/samhain.startSystemd
 init/samhain.startGentoo
 init/samhain.startFreeBSD
@@ -2869,42 +2281,25 @@
 init/samhain.startHPUX
 init/samhain.startIRIX
-init/samhain.startMACOSX
 samhain.spec
 rules.deb
 rules.deb-light
 hp_ux.psf
-scripts/logrotate
 scripts/samhain.spec
 scripts/redhat_i386.client.spec
 scripts/samhain.ebuild
 scripts/samhain.ebuild-light
-scripts/samhainadmin-gpg.pl
-scripts/samhainadmin-sig.pl
-scripts/yuleadmin.pl
+scripts/samhainadmin.pl
 scripts/check_samhain.pl
 deploy.sh
-])
-AC_CONFIG_COMMANDS([stamp-h],[
+],
+[
 echo timestamp > stamp-h
 chmod +x samhain-install.sh
-chmod +x scripts/samhainadmin-gpg.pl
-chmod +x scripts/samhainadmin-sig.pl
-chmod +x scripts/yuleadmin.pl
+chmod +x scripts/samhainadmin.pl
 chmod +x scripts/check_samhain.pl
 ]
 )
-AC_OUTPUT
 
 chmod +x deploy.sh
-
-if test "x${mysignify}" != x
-then
-	cp -a scripts/samhainadmin-sig.pl scripts/samhainadmin.pl
-fi 
-if test "x${mygpg}" != x
-then
-	cp -a scripts/samhainadmin-gpg.pl scripts/samhainadmin.pl
-fi 
-
 
 if test "x${cross_compiling}" = xyes
@@ -2921,5 +2316,5 @@
 echo "ac_cv_sizeof_char_p         size of pointer to char ${ac_cv_sizeof_char_p}"
 echo "ac_cv_sizeof_char_p         size of size_t          ${ac_cv_sizeof_size_t}"
-echo "ac_cv_sizeof_unsigned_int   size of unsigned int    ${ac_cv_sizeof_unsigned_int}"
+echo "ac_cv_sizeof_unsigned_int_  size of unsigned int    ${ac_cv_sizeof_unsigned_int_}"
 echo "ac_cv_sizeof_unsigned_long  size of unsigned long   ${ac_cv_sizeof_unsigned_long}"
 echo "ac_cv_sizeof_unsigned_short size of unsigned short  ${ac_cv_sizeof_unsigned_short}"
@@ -2947,13 +2342,8 @@
 	echo "  Configuration file: ${myconffile}"
 	echo "        Manual pages: ${mandir}"
-	echo "      Data directory: ${mydataroot}"
-	echo "       Database file: ${mydatafile}"
+	echo "                Data: ${mydataroot}"
 	echo "            PID file: ${mylockfile}"
 	echo "            Log file: ${mylogfile}"
 	echo "            Base key: ${mykeybase}"
-	if test x"$mykeyid" != x
-	then
-	    echo "  target GPG/PGP key: ${mykeyid}"
-	fi
 	echo
 	if test x"$mytclient" = x"-DSH_WITH_SERVER"
